<template>
  <div class="d-image-uploader">
    <div class="vx-row w-full mb-0 sm:mb-6">
      <div class="vx-col w-full mb-6 sm:mb-0">
        <div v-if="true" class="flex flex-wrap justify-around sm:justify-start">
          <div
            v-for="(image, index) in images"
            :key="index"
            class="image shadow-md mb-6 sm:mb-3 mr-0 sm:mr-3 rounded h-32 w-32 inline-block"
            :style="{
              'background-image': `url(${image})`
            }"
          >
            <div @click="removePhoto(index)" class="remove-btn"></div>
          </div>
          <div
            v-if="images.length < maxImages"
            @click="chooseImage"
            class="upload-wrapper shadow-md mr-0 sm:mr-3 rounded h-32 w-32 inline-block"
          >
            <img class="upload" src="@/components/d-elements/parts/images/upload_white.svg" />
          </div>
        </div>
      </div>
    </div>
    <input type="file" class="hidden" ref="imagesBrowser" name="images" accept=".png, .jpg, .jpeg" />
  </div>
</template>

<script>
import api from "@/api/image.api.ts";
import { cloneDeep } from "lodash";

export default {
  props: {
    maxImages: {
      requirerd: false,
      type: Number,
      default: 10
    },
    imagesIds: {
      requirerd: false,
      type: Array,
      default: () => []
    },
    loadImages: {
      requirerd: false,
      type: Boolean,
      default: false
    },
    pushImagesToServer: {
      requirerd: false,
      type: Boolean,
      default: false
    }
  },
  data() {
    return {
      images: [], // binary of images
      preloadedImagesIds: [], // must be always the same size as images
      uploadedImagesIds: [] // final ids returned to the component
    };
  },
  watch: {
    loadImages(val) {
      if (val) {
        this.getImagesByIds();
      }
    },

    pushImagesToServer(val) {
      if (val) {
        this.uploadImages();
      }
    },

    images(val) {
      this.$emit("changedQuantity", val.length);
    }
  },
  methods: {
    async getImagesByIds() {
      if (this.imagesIds.length > 0) {
        await api.getImages(this.imagesIds).then(response => {
          this.images = response.data;
          this.preloadedImagesIds = this.imagesIds; // we need to remember initial ids and be able to remove them from list
        });
      }
    },

    async uploadImages() {
      const preloadedIds = this.preloadedImagesIds.filter(
        i => i !== "newImage"
      );

      let newImagesToSend = cloneDeep(this.images);
      newImagesToSend.splice(0, preloadedIds.length); // upload only new images

      this.uploadedImagesIds = [];
      if (newImagesToSend.length > 0) {
        await api.uploadImages(newImagesToSend).then(response => {
          this.uploadedImagesIds.push(...preloadedIds);
          this.uploadedImagesIds.push(...response.data);
          // we don't want to get all images from server if we already have them
          let newImageIndex = 0;
          this.preloadedImagesIds.forEach((item, index) => {
            if (item === "newImage") {
              this.preloadedImagesIds[index] = response.data[newImageIndex];
              newImageIndex++;
            }
          });

          this.$emit("uploadedToServer", this.uploadedImagesIds);
        });
      } else {
        this.$emit("uploadedToServer", this.preloadedImagesIds);
      }
    },

    chooseImage() {
      this.$refs.imagesBrowser.click();

      this.$refs.imagesBrowser.onchange = () => {
        var file = this.$refs.imagesBrowser.files[0];
        var fr = new FileReader();
        fr.onload = () => {
          this.preloadedImagesIds.push("newImage");
          this.images.push(fr.result);
        };
        fr.readAsDataURL(file);
      };
    },

    removePhoto(id) {
      this.preloadedImagesIds.splice(id, 1); // we don't need it's id anymore
      this.images.splice(id, 1);
    }
  }
};
</script>

<style lang="scss">
.d-image-uploader {
  .image {
    width: 100%;
    height: 100%;
    background-position-x: 50%;
    background-size: cover;
  }
  .remove-btn {
    width: 21px;
    height: 21px;
    right: 0;
    position: relative;
    float: right;
    margin: 8px;
    background-size: contain;
    background-image: url("~@/components/d-elements/parts/images/x-cross.svg");
    cursor: pointer;
    z-index: 999;
    opacity: 0.92;
    transition: all 0.2s ease-in;

    &:hover {
      opacity: 1;
      transform: scale(1.17);
    }
  }

  .upload-wrapper {
    background-color: #c1c1c1;
    cursor: pointer;
    transition: all 0.2s ease-in;

    &:hover {
      background-color: #72afee;
    }

    .upload {
      width: 40px;
      height: 40px;
      margin: auto;
      margin-top: 37px;
      opacity: 0.87;
    }
  }
}
</style>